// Part of ImGui Bundle - MIT License - Copyright (c) 2022-2024 Pascal Thomet - https://github.com/pthom/imgui_bundle
#include <pybind11/pybind11.h>
#include <string>

namespace py = pybind11;

void py_init_module_hello_imgui(py::module& m);
void py_init_module_imgui_main(py::module& m);
void py_init_module_imgui_internal(py::module& m);
void py_init_module_imgui_test_engine(py::module& m);
void py_init_module_implot(py::module& m);
void py_init_module_imgui_color_text_edit(py::module& m);
void py_init_module_imgui_node_editor(py::module& m);
void py_init_module_imgui_knobs(py::module& m);
void py_init_module_im_file_dialog(py::module& m);
void py_init_module_imspinner(py::module& m);
void py_init_module_imgui_md(py::module& m);
void py_init_module_immvision(py::module& m);
void py_init_module_imgui_backends(py::module& m);
void py_init_module_imguizmo(py::module& m);
void py_init_module_imgui_tex_inspect(py::module& m);
void py_init_module_immapp_cpp(py::module& m);
void py_init_module_imgui_toggle(py::module& m);
void py_init_module_portable_file_dialogs(py::module& m);
void py_init_module_imgui_command_palette(py::module& m);
void py_init_module_implot_internal(py::module& m);
void py_init_module_imcoolbar(py::module& m);
void py_init_module_nanovg(py::module& m);


void py_init_module_imgui_bundle(py::module& m)
{
    m.def("compilation_time", []() {
        return std::string("imgui_bundle, compiled on ") + __DATE__ + " at " + __TIME__;
    });

    // imgui and its submodules
    auto module_imgui =  m.def_submodule("imgui");
    py_init_module_imgui_main(module_imgui);
    // Submodule imgui.internal
    auto module_imgui_internal =  module_imgui.def_submodule("internal");
    py_init_module_imgui_internal(module_imgui_internal);
    // Submodule imgui.backends
    auto module_imgui_backends =  module_imgui.def_submodule("backends");
    py_init_module_imgui_backends(module_imgui_backends);
    // Submodule imgui.test_engine
    auto module_imgui_test_engine =  module_imgui.def_submodule("test_engine");
    py_init_module_imgui_test_engine(module_imgui_test_engine);

    auto module_himgui =  m.def_submodule("hello_imgui");
    py_init_module_hello_imgui(module_himgui);

    auto module_implot =  m.def_submodule("implot");
    py_init_module_implot(module_implot);

    auto module_implot_internal = module_implot.def_submodule("internal");
    py_init_module_implot_internal(module_implot_internal);

    auto module_imgui_color_text_edit =  m.def_submodule("imgui_color_text_edit");
    py_init_module_imgui_color_text_edit(module_imgui_color_text_edit);

    auto module_imgui_node_editor =  m.def_submodule("imgui_node_editor");
    py_init_module_imgui_node_editor(module_imgui_node_editor);

    auto module_imgui_knobs =  m.def_submodule("imgui_knobs");
    py_init_module_imgui_knobs(module_imgui_knobs);

	auto module_im_file_dialog =  m.def_submodule("im_file_dialog");
	py_init_module_im_file_dialog(module_im_file_dialog);

    auto module_imspinner =  m.def_submodule("imspinner");
    py_init_module_imspinner(module_imspinner);

    auto module_imgui_md =  m.def_submodule("imgui_md");
    py_init_module_imgui_md(module_imgui_md);

    auto module_immvision =  m.def_submodule("immvision");
    py_init_module_immvision(module_immvision);

    auto module_imguizmo = m.def_submodule("imguizmo");
    py_init_module_imguizmo(module_imguizmo);

    auto module_imgui_tex_inspect = m.def_submodule("imgui_tex_inspect");
    py_init_module_imgui_tex_inspect(module_imgui_tex_inspect);

    auto module_immapp_cpp = m.def_submodule("immapp_cpp");
    py_init_module_immapp_cpp(module_immapp_cpp);

    auto module_imgui_toggle = m.def_submodule("imgui_toggle");
    py_init_module_imgui_toggle(module_imgui_toggle);

    auto module_portable_file_dialogs = m.def_submodule("portable_file_dialogs");
    py_init_module_portable_file_dialogs(module_portable_file_dialogs);

    auto module_imgui_command_palette = m.def_submodule("imgui_command_palette");
    py_init_module_imgui_command_palette(module_imgui_command_palette);

    auto module_imcooolbar = m.def_submodule("im_cool_bar");
    py_init_module_imcoolbar(module_imcooolbar);

    auto module_nanovg = m.def_submodule("nanovg");
    py_init_module_nanovg(module_nanovg);
}


// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!  AUTOGENERATED CODE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// <litgen_glue_code>  // Autogenerated code below! Do not edit!

// </litgen_glue_code> // Autogenerated code end
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!  AUTOGENERATED CODE END !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
